/* final project Fall 2001
 * Authors Stephen Callahan (dj) and Wayne Chan (di)
 * pfmLoadIcons.c
 */

#include <string.h>
#include <stdio.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include "LoadIcons.h"

int findAssoc(char* exten) {
	/* returns the texture number of a specific file extension,
	 * 0 if not found (default)
	 */
	int i;
	for (i = 1; i < 8; i ++) {
		if (strstr(extAssoc[i], exten) != NULL) {
			return i;
		}
		//printf("%d %s %s\n", i, extAssoc[i], exten);
	}
	return 0;
}

void loadPPM(char* file, int pos) {
	/* loads a single 128x128 or 64x64 icon
	 * icons are somewhat nonstandard ppms where
	 * no comments are allowed
	 */
	FILE * ppmfile;
	char * tmpstr1;
	int i, j, k, l, r, g, b;
	tmpstr1 = (char *)malloc(80 * sizeof(char));
	if ((ppmfile = fopen(file, "r")) == NULL) {
		printf("pimpfm: %s not found\n", file);
		exit(1);
	}
	fscanf(ppmfile, "%s", tmpstr1);
	if (strcmp(tmpstr1, "P3") != 0) {
		printf("pimpfm: %s is not a valid PPM file\n", file);
		exit(1);
	}
	fscanf(ppmfile, "%i %i", &i, &j);
	printf("%i %i", i, j);
	if ((i == texHeight/2) && (j == texWidth/2)) {
		if (pos == 0) {
			for (k = 0; k < texHeight/2; k += 1) {
				for (l = 0; l < texWidth/2; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex0[k * 2][l * 2][0] = (GLubyte) r;
					tex0[k * 2][l * 2][1] = (GLubyte) g;
					tex0[k * 2][l * 2][2] = (GLubyte) b;
					tex0[k * 2][l * 2][3] = (GLubyte) 255;
					tex0[k * 2][(l * 2) + 1][0] = (GLubyte) r;
					tex0[k * 2][(l * 2) + 1][1] = (GLubyte) g;
					tex0[k * 2][(l * 2) + 1][2] = (GLubyte) b;
					tex0[k * 2][(l * 2) + 1][3] = (GLubyte) 255;
					tex0[(k * 2) + 1][l * 2][0] = (GLubyte) r;
					tex0[(k * 2) + 1][l * 2][1] = (GLubyte) g;
					tex0[(k * 2) + 1][l * 2][2] = (GLubyte) b;
					tex0[(k * 2) + 1][l * 2][3] = (GLubyte) 255;
					tex0[(k * 2) + 1][(l * 2) + 1][0] = (GLubyte) r;
					tex0[(k * 2) + 1][(l * 2) + 1][1] = (GLubyte) g;
					tex0[(k * 2) + 1][(l * 2) + 1][2] = (GLubyte) b;
					tex0[(k * 2) + 1][(l * 2) + 1][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 1) {
			for (k = 0; k < texHeight/2; k += 1) {
				for (l = 0; l < texWidth/2; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex1[k * 2][l * 2][0] = (GLubyte) r;
					tex1[k * 2][l * 2][1] = (GLubyte) g;
					tex1[k * 2][l * 2][2] = (GLubyte) b;
					tex1[k * 2][l * 2][3] = (GLubyte) 255;
					tex1[k * 2][(l * 2) + 1][0] = (GLubyte) r;
					tex1[k * 2][(l * 2) + 1][1] = (GLubyte) g;
					tex1[k * 2][(l * 2) + 1][2] = (GLubyte) b;
					tex1[k * 2][(l * 2) + 1][3] = (GLubyte) 255;
					tex1[(k * 2) + 1][l * 2][0] = (GLubyte) r;
					tex1[(k * 2) + 1][l * 2][1] = (GLubyte) g;
					tex1[(k * 2) + 1][l * 2][2] = (GLubyte) b;
					tex1[(k * 2) + 1][l * 2][3] = (GLubyte) 255;
					tex1[(k * 2) + 1][(l * 2) + 1][0] = (GLubyte) r;
					tex1[(k * 2) + 1][(l * 2) + 1][1] = (GLubyte) g;
					tex1[(k * 2) + 1][(l * 2) + 1][2] = (GLubyte) b;
					tex1[(k * 2) + 1][(l * 2) + 1][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 2) {
			for (k = 0; k < texHeight/2; k += 1) {
				for (l = 0; l < texWidth/2; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex2[k * 2][l * 2][0] = (GLubyte) r;
					tex2[k * 2][l * 2][1] = (GLubyte) g;
					tex2[k * 2][l * 2][2] = (GLubyte) b;
					tex2[k * 2][l * 2][3] = (GLubyte) 255;
					tex2[k * 2][(l * 2) + 1][0] = (GLubyte) r;
					tex2[k * 2][(l * 2) + 1][1] = (GLubyte) g;
					tex2[k * 2][(l * 2) + 1][2] = (GLubyte) b;
					tex2[k * 2][(l * 2) + 1][3] = (GLubyte) 255;
					tex2[(k * 2) + 1][l * 2][0] = (GLubyte) r;
					tex2[(k * 2) + 1][l * 2][1] = (GLubyte) g;
					tex2[(k * 2) + 1][l * 2][2] = (GLubyte) b;
					tex2[(k * 2) + 1][l * 2][3] = (GLubyte) 255;
					tex2[(k * 2) + 1][(l * 2) + 1][0] = (GLubyte) r;
					tex2[(k * 2) + 1][(l * 2) + 1][1] = (GLubyte) g;
					tex2[(k * 2) + 1][(l * 2) + 1][2] = (GLubyte) b;
					tex2[(k * 2) + 1][(l * 2) + 1][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 3) {
			for (k = 0; k < texHeight/2; k += 1) {
				for (l = 0; l < texWidth/2; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex3[k * 2][l * 2][0] = (GLubyte) r;
					tex3[k * 2][l * 2][1] = (GLubyte) g;
					tex3[k * 2][l * 2][2] = (GLubyte) b;
					tex3[k * 2][l * 2][3] = (GLubyte) 255;
					tex3[k * 2][(l * 2) + 1][0] = (GLubyte) r;
					tex3[k * 2][(l * 2) + 1][1] = (GLubyte) g;
					tex3[k * 2][(l * 2) + 1][2] = (GLubyte) b;
					tex3[k * 2][(l * 2) + 1][3] = (GLubyte) 255;
					tex3[(k * 2) + 1][l * 2][0] = (GLubyte) r;
					tex3[(k * 2) + 1][l * 2][1] = (GLubyte) g;
					tex3[(k * 2) + 1][l * 2][2] = (GLubyte) b;
					tex3[(k * 2) + 1][l * 2][3] = (GLubyte) 255;
					tex3[(k * 2) + 1][(l * 2) + 1][0] = (GLubyte) r;
					tex3[(k * 2) + 1][(l * 2) + 1][1] = (GLubyte) g;
					tex3[(k * 2) + 1][(l * 2) + 1][2] = (GLubyte) b;
					tex3[(k * 2) + 1][(l * 2) + 1][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 4) {
			for (k = 0; k < texHeight/2; k += 1) {
				for (l = 0; l < texWidth/2; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex4[k * 2][l * 2][0] = (GLubyte) r;
					tex4[k * 2][l * 2][1] = (GLubyte) g;
					tex4[k * 2][l * 2][2] = (GLubyte) b;
					tex4[k * 2][l * 2][3] = (GLubyte) 255;
					tex4[k * 2][(l * 2) + 1][0] = (GLubyte) r;
					tex4[k * 2][(l * 2) + 1][1] = (GLubyte) g;
					tex4[k * 2][(l * 2) + 1][2] = (GLubyte) b;
					tex4[k * 2][(l * 2) + 1][3] = (GLubyte) 255;
					tex4[(k * 2) + 1][l * 2][0] = (GLubyte) r;
					tex4[(k * 2) + 1][l * 2][1] = (GLubyte) g;
					tex4[(k * 2) + 1][l * 2][2] = (GLubyte) b;
					tex4[(k * 2) + 1][l * 2][3] = (GLubyte) 255;
					tex4[(k * 2) + 1][(l * 2) + 1][0] = (GLubyte) r;
					tex4[(k * 2) + 1][(l * 2) + 1][1] = (GLubyte) g;
					tex4[(k * 2) + 1][(l * 2) + 1][2] = (GLubyte) b;
					tex4[(k * 2) + 1][(l * 2) + 1][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 5) {
			for (k = 0; k < texHeight/2; k += 1) {
				for (l = 0; l < texWidth/2; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex5[k * 2][l * 2][0] = (GLubyte) r;
					tex5[k * 2][l * 2][1] = (GLubyte) g;
					tex5[k * 2][l * 2][2] = (GLubyte) b;
					tex5[k * 2][l * 2][3] = (GLubyte) 255;
					tex5[k * 2][(l * 2) + 1][0] = (GLubyte) r;
					tex5[k * 2][(l * 2) + 1][1] = (GLubyte) g;
					tex5[k * 2][(l * 2) + 1][2] = (GLubyte) b;
					tex5[k * 2][(l * 2) + 1][3] = (GLubyte) 255;
					tex5[(k * 2) + 1][l * 2][0] = (GLubyte) r;
					tex5[(k * 2) + 1][l * 2][1] = (GLubyte) g;
					tex5[(k * 2) + 1][l * 2][2] = (GLubyte) b;
					tex5[(k * 2) + 1][l * 2][3] = (GLubyte) 255;
					tex5[(k * 2) + 1][(l * 2) + 1][0] = (GLubyte) r;
					tex5[(k * 2) + 1][(l * 2) + 1][1] = (GLubyte) g;
					tex5[(k * 2) + 1][(l * 2) + 1][2] = (GLubyte) b;
					tex5[(k * 2) + 1][(l * 2) + 1][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 6) {
			for (k = 0; k < texHeight/2; k += 1) {
				for (l = 0; l < texWidth/2; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex6[k * 2][l * 2][0] = (GLubyte) r;
					tex6[k * 2][l * 2][1] = (GLubyte) g;
					tex6[k * 2][l * 2][2] = (GLubyte) b;
					tex6[k * 2][l * 2][3] = (GLubyte) 255;
					tex6[k * 2][(l * 2) + 1][0] = (GLubyte) r;
					tex6[k * 2][(l * 2) + 1][1] = (GLubyte) g;
					tex6[k * 2][(l * 2) + 1][2] = (GLubyte) b;
					tex6[k * 2][(l * 2) + 1][3] = (GLubyte) 255;
					tex6[(k * 2) + 1][l * 2][0] = (GLubyte) r;
					tex6[(k * 2) + 1][l * 2][1] = (GLubyte) g;
					tex6[(k * 2) + 1][l * 2][2] = (GLubyte) b;
					tex6[(k * 2) + 1][l * 2][3] = (GLubyte) 255;
					tex6[(k * 2) + 1][(l * 2) + 1][0] = (GLubyte) r;
					tex6[(k * 2) + 1][(l * 2) + 1][1] = (GLubyte) g;
					tex6[(k * 2) + 1][(l * 2) + 1][2] = (GLubyte) b;
					tex6[(k * 2) + 1][(l * 2) + 1][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 7) {
			for (k = 0; k < texHeight/2; k += 1) {
				for (l = 0; l < texWidth/2; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex7[k * 2][l * 2][0] = (GLubyte) r;
					tex7[k * 2][l * 2][1] = (GLubyte) g;
					tex7[k * 2][l * 2][2] = (GLubyte) b;
					tex7[k * 2][l * 2][3] = (GLubyte) 255;
					tex7[k * 2][(l * 2) + 1][0] = (GLubyte) r;
					tex7[k * 2][(l * 2) + 1][1] = (GLubyte) g;
					tex7[k * 2][(l * 2) + 1][2] = (GLubyte) b;
					tex7[k * 2][(l * 2) + 1][3] = (GLubyte) 255;
					tex7[(k * 2) + 1][l * 2][0] = (GLubyte) r;
					tex7[(k * 2) + 1][l * 2][1] = (GLubyte) g;
					tex7[(k * 2) + 1][l * 2][2] = (GLubyte) b;
					tex7[(k * 2) + 1][l * 2][3] = (GLubyte) 255;
					tex7[(k * 2) + 1][(l * 2) + 1][0] = (GLubyte) r;
					tex7[(k * 2) + 1][(l * 2) + 1][1] = (GLubyte) g;
					tex7[(k * 2) + 1][(l * 2) + 1][2] = (GLubyte) b;
					tex7[(k * 2) + 1][(l * 2) + 1][3] = (GLubyte) 255;
				}
			}
		} else {
			printf("pimpfm: too many textures\n");
			exit(1);
		}
	} else if ((i == texHeight) && (j == texWidth)) {
		if (pos == 0) {
			for (k = 0; k < texHeight; k += 1) {
				for (l = 0; l < texWidth; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex0[k][l][0] = (GLubyte) r;
					tex0[k][l][1] = (GLubyte) g;
					tex0[k][l][2] = (GLubyte) b;
					tex0[k][l][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 1) {
			for (k = 0; k < texHeight; k += 1) {
				for (l = 0; l < texWidth; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex1[k][l][0] = (GLubyte) r;
					tex1[k][l][1] = (GLubyte) g;
					tex1[k][l][2] = (GLubyte) b;
					tex1[k][l][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 2) {
			for (k = 0; k < texHeight; k += 1) {
				for (l = 0; l < texWidth; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex2[k][l][0] = (GLubyte) r;
					tex2[k][l][1] = (GLubyte) g;
					tex2[k][l][2] = (GLubyte) b;
					tex2[k][l][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 3) {
			for (k = 0; k < texHeight; k += 1) {
				for (l = 0; l < texWidth; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex3[k][l][0] = (GLubyte) r;
					tex3[k][l][1] = (GLubyte) g;
					tex3[k][l][2] = (GLubyte) b;
					tex3[k][l][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 4) {
			for (k = 0; k < texHeight; k += 1) {
				for (l = 0; l < texWidth; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex4[k][l][0] = (GLubyte) r;
					tex4[k][l][1] = (GLubyte) g;
					tex4[k][l][2] = (GLubyte) b;
					tex4[k][l][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 5) {
			for (k = 0; k < texHeight; k += 1) {
				for (l = 0; l < texWidth; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex5[k][l][0] = (GLubyte) r;
					tex5[k][l][1] = (GLubyte) g;
					tex5[k][l][2] = (GLubyte) b;
					tex5[k][l][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 6) {
			for (k = 0; k < texHeight; k += 1) {
				for (l = 0; l < texWidth; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex6[k][l][0] = (GLubyte) r;
					tex6[k][l][1] = (GLubyte) g;
					tex6[k][l][2] = (GLubyte) b;
					tex6[k][l][3] = (GLubyte) 255;
				}
			}
		} else if (pos == 7) {
			for (k = 0; k < texHeight; k += 1) {
				for (l = 0; l < texWidth; l += 1) {
					fscanf(ppmfile, "%i %i %i", &r, &g, &b);
					tex7[k][l][0] = (GLubyte) r;
					tex7[k][l][1] = (GLubyte) g;
					tex7[k][l][2] = (GLubyte) b;
					tex7[k][l][3] = (GLubyte) 255;
				}
			}
		} else {
			printf("pimpfm: too many textures\n");
			exit(1);
		}
	} else {
		printf("pimpfm: %s is of invalid size\n", file);
		exit(1);
	}
	if (pos == 0) {
		glBindTexture(GL_TEXTURE_2D, texName[0]);
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, texWidth, texHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex0);
	} else if (pos == 1) {
		glBindTexture(GL_TEXTURE_2D, texName[1]);
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, texWidth, texHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex1);
	} else if (pos == 2) {
		glBindTexture(GL_TEXTURE_2D, texName[2]);
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, texWidth, texHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex2);
	} else if (pos == 3) {
		glBindTexture(GL_TEXTURE_2D, texName[3]);
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, texWidth, texHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex3);
	} else if (pos == 4) {
		glBindTexture(GL_TEXTURE_2D, texName[4]);
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, texWidth, texHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex4);
	} else if (pos == 5) {
		glBindTexture(GL_TEXTURE_2D, texName[5]);
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, texWidth, texHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex5);
	} else if (pos == 6) {
		glBindTexture(GL_TEXTURE_2D, texName[6]);
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, texWidth, texHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex6);
	} else if (pos == 7) {
		glBindTexture(GL_TEXTURE_2D, texName[7]);
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, texWidth, texHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex7);
	}
	printf("texture loaded\n");
}

void loadIcons(void) {
	FILE * cfgfile;
	char * tmpstr1;
	char tmpstr2[80];
	int i,j, k;
	tmpstr1 = (char *) malloc (80 * sizeof(char));
	if ((cfgfile = fopen("iconlist.cfg", "r")) == NULL) {
		printf("pimpfm: no iconlist.cfg file\n");
		exit(1);
	}
	glGenTextures(8, &texName[0]);
	for (i = 0; i < 8; i ++) {
		extAssoc[i] = (char *) malloc (10 * sizeof(char));
	}
	fscanf(cfgfile, "%s", tmpstr1);
	if (strcmp(tmpstr1, "DEFAULT") != 0) {
		printf("pimpfm: no default defined in iconlist.cfg\n");
		exit(1);
	} else {
		fscanf(cfgfile, "%s", tmpstr2);
		loadPPM(tmpstr2, 0);
		extAssoc[0] = "qqqq";
	}
	free(tmpstr1);
	for (i = 1; i < 8; i += 1) {
		tmpstr1 = (char *) malloc (80 * sizeof(char));
		if (fscanf(cfgfile, "%s", tmpstr1) == 1) {
			j = strlen(tmpstr1);
			for (k = 0; k < j; k ++) {
				extAssoc[i][k] = tmpstr1[k];
			}
			fscanf(cfgfile, "%s", tmpstr2);
			loadPPM(tmpstr2, i);
			printf("%s\n", extAssoc[i]);
		} else {
			extAssoc[i] = "qqqq";
		}
		free(tmpstr1);
	}
}
