/* *******************************
 * this the library for drawing
 * icons on the glarea window.
 * There's a lot to it, just 
 * hold on for the ride.
 * ******************************/
#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <gtkgl/gtkglarea.h>
#include <stdio.h>
#include <string.h>
#include <glib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/dir.h>
#include <unistd.h>
#include "dirs.h"
#include "draw.h"
#include "LoadIcons.h"

void init2D (GtkWidget *widget) {
	glDisable(GL_LIGHT0);
	glDisable(GL_LIGHTING);
	glDisable(GL_CULL_FACE);
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_COLOR_MATERIAL);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-20.0,70.0,00.0, 100.0,-20.0,40.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void init3D (GtkWidget *widget) {
	float lightpos[] = {0.0f, 5.5f, -1.0f, 1.0f};
	float ambient[] = {0.8f, 0.8f, 0.8f, 1.0f};
	float diffuse[] = {0.4f, 0.4f, 0.4f, 1.0f};
	float specular[] = {0.3f, 0.3f, 0.3f, 1.0f};
	float specref[] = {0.9f, 0.9f, 0.9f, 0.9f};
	//glEnable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_CULL_FACE);
	glFrontFace(GL_CCW);
	glEnable(GL_TEXTURE_2D);
	glShadeModel(GL_SMOOTH);
	glEnable(GL_LIGHTING);
	glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
	glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
	glLightfv(GL_LIGHT0, GL_SPECULAR, specular);
	glEnable(GL_LIGHT0);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//glFrustum (0.0, 100.0, 100.0, 0.0, -1.0, 100.0);
	gluPerspective(60, widget->allocation.width/widget->allocation.height, 1.5, 10000.0);
	//glOrtho(-20.0,70.0,0.0, 100.0,-20.0,40.0);
	glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
	glMaterialfv(GL_FRONT, GL_SPECULAR, specref);
	glMateriali(GL_FRONT, GL_SHININESS, 0);
	glEnable(GL_COLOR_MATERIAL);
	glMatrixMode(GL_MODELVIEW);
	glClearColor(0, 0, 0, 1);
	glLoadIdentity();

	//glOrtho(0, 300, 0, 300, 0, 300);
	gluLookAt(2, -2.5, -5, 2, 2, 2, 0, 0, 1);
	
}

void draw2D (GtkWidget *widget, GdkEventExpose *event){
	glClearColor(0,0,0,1);
	glClear(GL_COLOR_BUFFER_BIT);
	glColor3f(0.0, 0.0, 1.0);
	//glBegin (GL_TRIANGLES);
	//glVertex2f(10,10);
	//glVertex2f(90, 90);
	//glVertex2f(10,90);
	//glEnd();
	pFiles = g_list_first(pFiles);
	while (g_list_next(pFiles) != NULL) {
		draw2dIcon((pFile *) pFiles->data);
		pFiles = g_list_next(pFiles);
	}
	draw2dIcon((pFile *) pFiles->data);
	gtk_gl_area_swapbuffers(GTK_GL_AREA(widget));
}

void draw3D (GtkWidget *widget, GdkEventExpose *event){
	glClearColor(0,0,0,1);
	glClear(GL_COLOR_BUFFER_BIT);
	//glColor3f(0.0,0.5,1.0);
	//glBegin(GL_TRIANGLES);
	//glVertex3f(1, 1, 0);
	//glVertex3f(1, 0, 0);
	//glVertex3f(0, 0, 0);
	//glEnd();
	glColor3f(0.0, 0.0, 1.0);
	//glutSolidTorus(0.75, 2.0, 40, 40);
	pFiles = g_list_last(pFiles);
	while (g_list_previous(pFiles) != NULL) {
		if (iconMode == JULIA) {
			draw3dIcon((pFile *) pFiles->data);
		}else {
			prettyIcon((pFile *) pFiles->data);
		}
		pFiles = g_list_previous(pFiles);
	}
	if (iconMode == JULIA) {
		draw3dIcon((pFile *) pFiles->data);
	} else {
		prettyIcon((pFile *) pFiles->data);
	}
	gtk_gl_area_swapbuffers(GTK_GL_AREA(widget));
}

void draw2dIcon(pFile * file) {
	char *let;
	strafe2To();
	glTranslatef(file->x, file->y, file->z);
	if (S_ISLNK(file->data.st_mode)) {
		glColor3f(0, 0.9, 0.8);
	} else  if (S_ISDIR (file->data.st_mode)) {
		glColor3f(0, 0.0, 1.0);
	} else {
		glColor3f(1.0, 0, 0);
	}
	glBegin(GL_POLYGON);
	glVertex3d(-3, 5, 0);
	if (file->selected) {
		glColor3f(1.0, 0, 1.0);
	}
	glVertex3d(-3, -5, 0);
	glVertex3d(3, -5, 0);
	if (file->selected) {
		glColor3f(0.0, 1.0, 0.1);
	}
	glVertex3d(3, 5, 0);
	glEnd();
	let = file->name;
	glRasterPos2i(-3,-8);
	while (*let != '\0') {
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, *let);
		let++;
	}
	glTranslatef(-(file->x), - (file->y), -(file->z));
	strafe2Back();
}

void draw3dIcon(pFile * file) {
	int rotated;
	char * let;
	float i;
	if (file->z < selected->z) {
		i = 0.25;
	} else if (file->copied) {
		i = 0.5;
	} else {
		i = 1.0;
	}
	strafeTo();
	glTranslatef(file->x, file->y, file->z);
	//glcolor call should be dependent upon executability and such
	//front
	//A gl texture call should be here to give icon
	if (S_ISLNK(file->data.st_mode)) {
		glColor4f(0, 0.9, 0.8, i);
	} else  if (S_ISDIR (file->data.st_mode)) {
		glColor4f(0, 0.0, 1.0, i);
	} else {
		glColor4f(1.0, 0, 0, i);
	}
	if (file->selected && (g_timer_elapsed(tooShort, NULL) > .025)) {
		g_timer_reset(tooShort);
		file->angle++;
	} 
	if (file->selected) {
		glRotated (file->angle, 0.0, 1.0, 0.0);
		rotated = 1;
	} else {
		rotated = 0;
	}
	glBegin(GL_POLYGON);
	glVertex3d(-3.0, 5.0, 0.5);
	if (file->selected) {
		glColor4f(1.0, 0, 1.0, i);
	}
	glVertex3d(-3.0, -5.0, 0.5);
	if (file->selected) {
		glColor4f(1.0, 0, 0.0, i);
	}
	glVertex3d(3.0, -5.0, 0.5);
	if (file->selected) {
		glColor4f(0.0, 0.7, 0.8, i);
	}
	glVertex3d(3.0, 5.0, 0.5);
	glEnd();
	glColor4f(1, 1, 0, i);
	//back
	glColor4f(0.0, 0.0, 1.0, i);
	glBegin(GL_POLYGON);
	glVertex3d(3.0, 5.0, -0.5);
	if (file->selected) {
		glColor4f(1, 1, 0, i);
	}
	glVertex3d(3.0, -5.0, -0.5);
	if (file->selected) {
		glColor4f(1, 0, 0, i);
	}
	glVertex3d(-3.0, -5.0, -0.5);
	glVertex3d(-3.0, 5.0, -0.5);
	glEnd();
	glColor3f(0, 1, 0);
	//top
	if (S_ISLNK(file->data.st_mode)) {
		glColor4f(1.0, 0.0, 0.8, i);
	} else  if (S_ISDIR (file->data.st_mode)) {
		glColor4f(0, 1.0, 0.0, i);
	} else {
		glColor4f(0, 1.0, 1.0, i);
	}
	glBegin(GL_POLYGON);
	glVertex3d(-3.0, 5.0, -0.5);
	glVertex3d(-3.0, 5.0, 0.5);
	glVertex3d(3.0, 5.0, 0.5);
	glVertex3d(3.0, 5.0, -0.5);
	glEnd();
	//bottom
	glBegin(GL_POLYGON);
	glVertex3d(3.0, -5.0, -0.5);
	glVertex3d(3.0, -5.0, 0.5);
	glVertex3d(-3.0, -5.0, 0.5);
	glVertex3d(-3.0, -5.0, -0.5);
	glEnd();
	//left
	glBegin(GL_POLYGON);
	glVertex3d(-3.0, 5.0, -0.5);
	glVertex3d(-3.0, -5.0, -0.5);
	glVertex3d(-3.0, -5.0, 0.5);
	glVertex3d(-3.0, 5.0, 0.5);
	glEnd();
	//right
	//glColor3f(1, 0, 0);
	glBegin(GL_POLYGON);
	glVertex3d(3.0, 5.0, 0.5);
	glVertex3d(3.0, -5.0, 0.5);
	glVertex3d(3.0, -5.0, -0.5);
	glVertex3d(3.0, 5.0, -0.5);
	glEnd();
	let = file->name;
	glRasterPos2i(1,8);
	while (*let != '\0') {
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, *let);
		let++;
	}
	if (rotated) {		
		glRotated (-(file->angle), 0.0, 1.0, 0.0);
	}
	glTranslatef(-(file->x), - (file->y), -(file->z));
	strafeBack();
}

void prettyIcon(pFile * file) {
	int rotated;
	/* added 12-4-01 */
	int textureNum;
	enum mime mimetype;
	char * let;
	float i;
	if (file->z < selected->z) {
		i = 0.25;
	} else if (file->copied) {
		i = 0.5;
	} else {
		i = 1.0;
	}
	strafeTo();
	glTranslatef(file->x, file->y, file->z);
	//glcolor call should be dependent upon executability and such
	/* insert mime type determination here */
	mimetype = file->filetype;
	if (*(file->name) == '.') {
		textureNum = findAssoc("HIDD");
	} else if (mimetype == PL) {
		textureNum = findAssoc("pl");
	} else if (mimetype == TXT) {
		textureNum = findAssoc("txt");
	} else if (mimetype == DOC) {
		textureNum = findAssoc("doc");
	} else if (mimetype == CPP) {
		textureNum = findAssoc("cpp");
	} else if (mimetype == C) {
		textureNum = findAssoc("c");
	} else if (mimetype == EL) {
		textureNum = findAssoc("el");
	} else if (mimetype == ZIP) {
		textureNum = findAssoc("zip");
	} else if (mimetype == JPG) {
		textureNum = findAssoc("jpg");
	} else if (S_ISDIR (file->data.st_mode)) {
		textureNum = findAssoc("DIRS");
	} else {
		textureNum = 0;
		/* mime type not associated with icon */
	}

	//front
	//A gl texture call should be here to give icon

	glBindTexture(GL_TEXTURE_2D, texName[textureNum]);

	if (S_ISLNK(file->data.st_mode)) {
		glColor4f(0, 0.9, 0.8, i);
	} else  if (S_ISDIR (file->data.st_mode)) {
		glColor4f(0, 0.0, 1.0, i);
	} else {
		glColor4f(1.0, 0, 0, i);
	}
	if (file->selected && (g_timer_elapsed(tooShort, NULL) > .025)) {
		g_timer_reset(tooShort);
		file->angle++;
	}
	if (file->selected) {
		glRotated (file->angle, 0.0, 1.0, 0.0);
		rotated = 1;
	} else {
		rotated = 0;
	}
	glBegin(GL_POLYGON);
	glTexCoord2f(0.0, 1.0);
	glVertex3d(-3.0, 5.0, 0.5);
	if (file->selected) {
		glColor4f(1.0, 0, 1.0, i);
	}
	glTexCoord2f(0.0, 0.0);
	glVertex3d(-3.0, -5.0, 0.5);
	if (file->selected) {
		glColor4f(1.0, 0, 0.0, i);
	}
	glTexCoord2f(1.0, 0.0);
	glVertex3d(3.0, -5.0, 0.5);
	if (file->selected) {
		glColor4f(0.0, 0.7, 0.8, i);
	}
	glTexCoord2f(1.0, 1.0);
	glVertex3d(3.0, 5.0, 0.5);
	glEnd();
	glColor4f(1, 1, 0, i);
	//back
	glColor4f(0.0, 0.0, 1.0, i);
	glBegin(GL_POLYGON);
	glTexCoord2f(1.0, 1.0);
	glVertex3d(3.0, 5.0, -0.5);
	if (file->selected) {
		glColor4f(1, 1, 0, i);
	}
	glTexCoord2f(1.0, 0.0);
	glVertex3d(3.0, -5.0, -0.5);
	if (file->selected) {
		glColor4f(1, 0, 0, i);
	}
	glTexCoord2f(0.0, 0.0);
	glVertex3d(-3.0, -5.0, -0.5);
	glTexCoord2f(0.0, 1.0);
	glVertex3d(-3.0, 5.0, -0.5);
	glEnd();
	glDisable(GL_TEXTURE_2D);
	glColor4f(0, 1, 0, i);
	//top
	if (S_ISLNK(file->data.st_mode)) {
		glColor4f(1.0, 0.0, 0.8, i);
	} else  if (S_ISDIR (file->data.st_mode)) {
		glColor4f(0, 1.0, 0.0, i);
	} else {
		glColor4f(0, 1.0, 1.0, i);
	}
	glBegin(GL_POLYGON);
	glVertex3d(-3.0, 5.0, -0.5);
	glVertex3d(-3.0, 5.0, 0.5);
	glVertex3d(3.0, 5.0, 0.5);
	glVertex3d(3.0, 5.0, -0.5);
	glEnd();
	//bottom
	glBegin(GL_POLYGON);
	glVertex3d(3.0, -5.0, -0.5);
	glVertex3d(3.0, -5.0, 0.5);
	glVertex3d(-3.0, -5.0, 0.5);
	glVertex3d(-3.0, -5.0, -0.5);
	glEnd();
	//left
	glBegin(GL_POLYGON);
	glVertex3d(-3.0, 5.0, -0.5);
	glVertex3d(-3.0, -5.0, -0.5);
	glVertex3d(-3.0, -5.0, 0.5);
	glVertex3d(-3.0, 5.0, 0.5);
	glEnd();
	//right
	//glColor4f(1, 0, 0);
	glBegin(GL_POLYGON);
	glVertex3d(3.0, 5.0, 0.5);
	glVertex3d(3.0, -5.0, 0.5);
	glVertex3d(3.0, -5.0, -0.5);
	glVertex3d(3.0, 5.0, -0.5);
	glEnd();
	let = file->name;
	glRasterPos2i(1,8);
	while (*let != '\0') {
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, *let);
		let++;
	}
	if (rotated) {		
		glRotated (-(file->angle), 0.0, 1.0, 0.0);
	}
	glEnable(GL_TEXTURE_2D);
	glTranslatef(-(file->x), - (file->y), -(file->z));
	strafeBack();
}

void strafeTo () {
	glTranslatef((float) strafeX, (float) strafeY, (float) strafeZ);
}

void strafeBack () {
	glTranslatef((float) -strafeX, (float) -strafeY, (float) -strafeZ);
}

void clearStrafe() {
	strafeX = 0;
	strafeY = 0;
	strafeZ = 0;
}

void strafe2To() {
	glTranslatef((float) strafeX, (float) strafeY, (float) 0);
}

void strafe2Back() {
	glTranslatef((float) -strafeX, (float) -strafeY, (float) 0);
}
