#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <gnome.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <glib.h>
#include <gtkgl/gtkglarea.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/dir.h>
#include <unistd.h>
#include "dirs.h"
#include "step2.h"
#include "draw.h"
#include "behavior.h"
#include "LoadIcons.h"

static gchar app_id[] = { "step2" };

gint main (gint argc, gchar ** argv) {
	//variables
	GtkWidget * mainappwindow;
	//initial junk
	username = (char *) g_get_user_name();
	homedir = (char *) g_get_home_dir();
	g_print ("%s", argv[0]);
	if (argc > 1) {
		current = argv[1];
	} else {
		current = homedir;
	}
	//dirHistory is the previously visited directories, it can move 
	//foward and backward
	//display mode set to hide hidden
	displayMode = HIDE;
	iconMode = PRETTY;
	dirHistory = NULL;
	dirHistory = g_list_append (dirHistory, current);
	selected = NULL;
	//for wayne's stuff
	////pFiles is a list of all the files in the current directory
	//there are also some bells and whistles to help with drawing
	pFiles = NULL;
	makePFiles(VIEW3D);//generate list
	//currentView sets which drawing mode
	currentView = VIEW3D;
	//gui stuff
	//initiallize strafing variables
	strafeX = -23;
	strafeY = 2;
	strafeZ = 28;
	tooShort = g_timer_new();
	g_timer_start(tooShort);
	//g_print("%s, and %c", g_get_home_dir(), current[0]);
	cutP = 0;
	copyP = 0;
	gnome_init (app_id, "0.0.1", argc, argv);
	mainappwindow = gnome_app_new (app_id, "step2: 3D File Manager");
	gtk_window_set_default_size (GTK_WINDOW (mainappwindow), 750, 550);
	gtk_signal_connect (GTK_OBJECT (mainappwindow), "destroy", GTK_SIGNAL_FUNC (CloseTheApp), NULL);
	gnome_app_create_menus (GNOME_APP (mainappwindow), main_menu);
	gnome_app_create_toolbar (GNOME_APP (mainappwindow), navigation_menu);
	if (gdk_gl_query() == FALSE) {
		g_print("OpenGL is not supported\n");
		return 0;
	}
	glarea = GTK_WIDGET(gtk_gl_area_new(attrlist));//add glarea
	if (glarea == NULL) {
		g_print ("You can't run OpenGL");
	}
	gtk_widget_set_events(GTK_WIDGET(glarea), GDK_BUTTON_PRESS_MASK| GDK_BUTTON1_MOTION_MASK|GDK_BUTTON2_MOTION_MASK|GDK_BUTTON3_MOTION_MASK|GDK_KEY_PRESS_MASK|GDK_KEY_RELEASE_MASK|GDK_BUTTON_RELEASE_MASK|GDK_KEY_PRESS_MASK|GDK_KEY_RELEASE_MASK|GDK_SHIFT_MASK|GDK_CONTROL_MASK);
	//gtk_widget_set_events(GTK_WIDGET(glarea), GDK_ALL_EVENTS_MASK);
	gtk_signal_connect(GTK_OBJECT(glarea), "event", GTK_SIGNAL_FUNC(stuffHappenned), NULL);
	gtk_signal_connect(GTK_OBJECT(glarea), "configure_event", GTK_SIGNAL_FUNC(reshape), NULL);
	gtk_signal_connect(GTK_OBJECT(glarea), "realize", GTK_SIGNAL_FUNC(initializeArea), NULL);
	gtk_widget_set_events(GTK_WIDGET(mainappwindow), GDK_ALL_EVENTS_MASK);
	gtk_signal_connect(GTK_OBJECT(mainappwindow), "event", GTK_SIGNAL_FUNC(keys), NULL);
	gtk_widget_set_usize(GTK_WIDGET(glarea), 300,300);
	gnome_app_set_contents (GNOME_APP(mainappwindow), glarea);
	gtk_widget_show(glarea);
	gtk_widget_show (mainappwindow);
	gtk_idle_add(redrawWindow, NULL);
	loadIcons();
	gtk_main ();
	return 0;
}
//So you can close the program
void CloseTheApp (GtkWidget * window, gpointer data) {
	gtk_main_quit();
}
void spawnNewWindow() {
	gnome_execute_shell(NULL, "./pimpFM");
	//g_print ("this works\n");//just checking
}
void openNewDir() {
	char * command[2];
	command[0] = "./pimpFM";
	command[1] = current;
	gnome_execute_async(NULL, 2, command);
	
	//g_print ("I need to learn threads\n");
}

void closeThisWindow() {
	gtk_main_quit(); //that'll do until threading works
}

void exitProgram() {
	gtk_main_quit();
}

gint initializeArea(GtkWidget *widget) {
	if (gtk_gl_area_make_current(GTK_GL_AREA(widget))) {
		glViewport(0,0, widget->allocation.width, widget->allocation.height);
		if (currentView == VIEW2D) {
			init2D(widget);
		} else {
			init3D(widget);
		}
	}
	return TRUE;
}

gint redrawWindow (void) {
	if (gtk_gl_area_make_current (GTK_GL_AREA(glarea))) {
		if (currentView == VIEW2D) {
			draw2D(glarea, NULL);
		} else {
			draw3D(glarea, NULL);
		}
		//sleep (1);
		//g_print("I'm running\n");
		return TRUE;
	} else {
		return FALSE;
	}
}

gint draw(GtkWidget *widget, GdkEventExpose *event) {
	if (event != NULL && event->count > 0) {
		return TRUE;
	}
	if (gtk_gl_area_make_current (GTK_GL_AREA(widget))) {
		if (currentView == VIEW2D) {
			draw2D(widget, event);
		} else {
			draw3D(widget, event);
		}
		return TRUE;
	}
}
gint reshape (GtkWidget *widget, GdkEventConfigure *event)
{
	if (gtk_gl_area_make_current(GTK_GL_AREA(widget))) {
		glViewport(0,0,widget->allocation.width, widget->allocation.height);
		/* *******************************
		 * later so that when people resize
		 * the icons don't just get larger
		 * make this code also change 
		 * gluPerspective and glOrtho
		 * *******************************/
	}
	return TRUE;
}

void helpAbout() {
	GtkWidget *bragBox;

	const gchar *writtenBy[] = {
		"Stephen Callahan",
		"and Wayne Chan", 
		NULL
	};
	bragBox = gnome_about_new ("step2: 3D File Manager", "0.2", "(C) 2002 Stephen Callahan & Wayne Chan", writtenBy, "Stephen \"The CalMan\" Callahan and Wayne \"Ne0n\" Chan", NULL);
	gtk_widget_show(bragBox);
}

void moveFoward () {
	moveToNext();
	g_print("%s\n", current);
	draw (glarea, NULL);
}

void moveBackward () {
	moveToPrev();
	g_print("%s\n", current);
	draw (glarea, NULL);
}

void moveUpward () {
	moveUp();
	g_print("%s\n", current);
	draw (glarea, NULL);
}

void goHomeward () {
	moveToHome();
	g_print("%s\n", current);
	draw (glarea, NULL);
}

void search() {
}

void showBooring() {
}

void addNewFile() {
	openNewDir();
}

void cutFunc() {
	cutP = TRUE;
	copyP = FALSE;
	selected->copied = TRUE;
	cutItem = (char *) malloc (sizeof (char) * (strlen(selected->nameTotal) + 1));
	cutItem = strcpy (cutItem, selected->nameTotal);
	cutShort = (char *) malloc (sizeof (char) * strlen(selected->name));
	cutShort = strcpy (cutShort, selected->name);
}

void copyFunc() {
	copyP = TRUE;
	cutP = FALSE;
	selected->copied = TRUE;
	copyItem = (char *) malloc (sizeof (char) * strlen(selected->nameTotal));
	copyItem = strcpy (copyItem, selected->nameTotal);
	copyShort = (char *) malloc (sizeof (char) * strlen(selected->name));
	copyShort = strcpy (copyShort, selected->name);
}

void filecopy(FILE * in, FILE * out) {
	int c;
	while ((c = getc(in)) != EOF) {
		putc(c, out);
	}
}


void pasteFunc() {
	FILE * infile;
	FILE * outfile;
	char * dest;
	char * destshort;
	//dest = (char *) malloc (sizeof (char) * ((strlen (cutShort)) + (strlen (current) + 2)));
	if (cutP) {
		dest = (char *) malloc (sizeof (char) * (strlen (cutShort) + strlen(current) + 2));
		dest = strcpy (dest, current);
		destshort = (char *) (dest + (sizeof(char) * strlen(current)));
		destshort[0] = '/';
	        destshort = (char *) (destshort + (sizeof(char)));
		destshort = strcpy (destshort, cutShort);
		rename(cutItem, dest);
	} else if (copyP) {
		dest = (char *) malloc (sizeof (char) * (strlen (copyShort) + strlen(current) + 2));
		dest = strcpy (dest, current);
		destshort = (char *) (dest + (sizeof(char) * strlen(current)));
		destshort[0] = '/';
		destshort = (char *) (destshort + (sizeof(char)));
		destshort = strcpy (destshort, copyShort);
		//Kernighan and Ritchie page 162
		if ((infile = fopen(copyItem, "r")) == NULL) {
			fprintf(stderr, "can't open file %s\n", copyItem);
			exit(1);
		} else {
			if ((outfile = fopen(dest, "w")) == NULL) {
				fprintf(stderr, "can't open file %s\n", dest);
				exit(1);
			} else {
				filecopy(infile, outfile);
				fclose(infile);
				fclose(outfile);
			}
		}
	}
}

void set3d() {
	currentView = VIEW3D;
	killPFiles();
	makePFiles(VIEW3D);
	init3D(glarea);
	repositionFiles(VIEW3D);
	clearStrafe();
	draw (glarea, NULL);
}

void set2d() {
	currentView = VIEW2D;
	killPFiles();
	makePFiles(VIEW2D);
	init2D(glarea);
	repositionFiles(VIEW2D);
	clearStrafe();
	draw (glarea, NULL);
}

void hide() {
	displayMode = HIDE;
	if (currentView == VIEW2D) {
		set2d();
	} else {
		set3d();
	}
}

void show() {
	displayMode = SHOWALL;
	if (currentView == VIEW2D) {
		set2d();
	} else {
		set3d();
	}
}

void iconned() {
	iconMode = PRETTY;
	//if (currentView == VIEW2D) {
	//	set2d();
	//} else {
	//	set3d();
	//}
}

void julia() {
	iconMode = JULIA;
	//if (currentView == VIEW2D) {
	//	set2d();
	//} else {
	//	set3d();
	//}
}

